Bug 718085

Summary: Erlang WX Driver failed to start due to C++ type mismatch.
Product: [Fedora] Fedora Reporter: xaoc <bugzilla>
Component: erlangAssignee: Peter Lemenkov <lemenkov>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: high Docs Contact:
Priority: unspecified    
Version: 14CC: lemenkov, metherid, rhbugs, wmealing
Target Milestone: ---   
Target Release: ---   
Hardware: i686   
OS: Linux   
Whiteboard:
Fixed In Version: erlang-R14B-03.2.fc15 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-07-31 03:38:34 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 689930    
Bug Blocks:    

Description xaoc 2011-06-30 22:22:47 UTC
Description of problem:

wx driver can't load wx shared lib due to type mismatch.

Version-Release number of selected component (if applicable):

erlang-wx-R14B-02.1.fc14.i686

How reproducible:

$ erl
Erlang R14B02 (erts-5.8.3) [source] [smp:2:2] [rq:2] [async-threads:0] [kernel-poll:false]

Eshell V5.8.3  (abort with ^G)
1> wx:new().

=ERROR REPORT==== 30-Jun-2011::18:16:20 ===
WX Failed loading "wxe_driver"@"/usr/lib/erlang/lib/wx-0.98.9/priv" 
** exception error: {load_driver,"symbol _ZN16wxStyledTextCtrl7SendMsgEill, version WXU_2.8 not defined in file libwx_gtk2u_stc-2.8.so.0 with link time reference"}
     in function  wxe_server:start/0
     in call from wx:new/1
2> 


Additional info:

Erlang WX driver looks for mangled name _ZN16wxStyledTextCtrl7SendMsgEill in the library libwx_gtk2u_stc-2.8.so.0, which has instead _ZN16wxStyledTextCtrl7SendMsgEiml:
$ strings /usr/lib/libwx_gtk2u_stc-2.8.so.0 |grep _ZN16wxStyledTextCtrl7SendMsgEi
_ZN16wxStyledTextCtrl7SendMsgEiml

i.e. Erlang WX driver looks for: wxStyledTextCtrl::SendMsg(int, long, long)
but actual library has: wxStyledTextCtrl::SendMsg(int, unsigned long, long)

$ rpm -qf /usr/lib/libwx_gtk2u_stc-2.8.so.0
wxGTK-2.8.12-1.fc14.i686

Comment 1 xaoc 2011-07-02 04:49:18 UTC
Not sure why wxGTK headers have been changed, but simple rebuild of the erlang rpms from source fixed the problem. Could erlang be scheduled for rebuild any soon?

Comment 2 Wade Mealing 2011-07-19 16:19:08 UTC
Still seeing this in 15.  Can I help with any additional testing Peter ?

Comment 3 Wade Mealing 2011-07-19 16:21:35 UTC
Specific error message that I'm getting.

(mysample@127.0.0.1)4> wx:new().

=ERROR REPORT==== 20-Jul-2011::02:16:53 ===
WX Failed loading "wxe_driver"@"/home/wmealing/Documents/workspace/mysample/rel/mysample/lib/wx-0.98.9/priv" 
** exception error: {load_driver,"symbol _ZN16wxStyledTextCtrl7SendMsgEill, version WXU_2.8 not defined in file libwx_gtk2u_stc-2.8.so.0 with link time reference"}
     in function  wxe_server:start/0
     in call from wx:new/1

Versions:
 erlang-wx-R14B-02.1.fc15.x86_64
 wxGTK-2.8.12-1.fc15.x86_64

Comment 4 xaoc 2011-07-19 16:28:03 UTC
Peter, please recompile.... It's not actually a bug - just matter of versions synchronization... just simple recompiling would solve this annoying (for more than 2 week) problem and make people happy!
Thanks.

Comment 5 Peter Lemenkov 2011-07-19 17:34:43 UTC
(In reply to comment #4)
> Peter, please recompile.... It's not actually a bug - just matter of versions
> synchronization... just simple recompiling would solve this annoying (for more
> than 2 week) problem and make people happy!
> Thanks.

I cant simply recompile it w/o adding NEVR issues which I'd like to avoid. And the recompilation in Rawhide is blocked by another issue (see issue #689930).

Comment 6 Wade Mealing 2011-07-20 05:47:08 UTC
Is there any reason you can't just add a 1 after the dist tag ?

Comment 8 Fedora Update System 2011-07-21 09:00:10 UTC
erlang-R14B-03.2.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/erlang-R14B-03.2.fc15

Comment 9 Fedora Update System 2011-07-21 09:00:38 UTC
erlang-R14B-03.1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/erlang-R14B-03.1.fc14

Comment 10 Fedora Update System 2011-07-23 01:58:03 UTC
Package erlang-R14B-03.2.fc15:
* should fix your issue,
* was pushed to the Fedora 15 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing erlang-R14B-03.2.fc15'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/erlang-R14B-03.2.fc15
then log in and leave karma (feedback).

Comment 11 xaoc 2011-07-23 04:53:40 UTC
Works now, thank you!

Comment 12 Wade Mealing 2011-07-26 00:44:20 UTC
Beauty ! All good on this end.  Karma deposited.

Comment 13 Fedora Update System 2011-07-31 03:38:17 UTC
erlang-R14B-03.1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2011-07-31 04:00:58 UTC
erlang-R14B-03.2.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.